/**
 * @author ::Awoken:: mothership-games@outlook.com
**/


function SPHERE( radius , detail , vertexNormals , preserve ){

	var r = radius || 1;
	var d = detail || 0;
	var uv = vertexNormals || false; // if set to true will compute vertexNormals
	var o = preserve || false; // if set to true will preserve s & cv

	var g = this.defineBaseVertices();
	g = this.defineBaseFaces( g , 4 );

	for( var i=d; i>1; i-- ){
		g = this.expand4( g , true );
	}

	if( d > 0 ){ o ? g = this.expand4( g , true ) : g = this.expand4( g , false ); }

	for( var i=0, j=g.vertices.length; i<j; i++ ){
		g.vertices[ i ].multiplyScalar( r );
	}

	g.computeFaceNormals();

	if( uv ){ g.computeVertexNormals(); }

	return g;
}

SPHERE.prototype = {

	constructor: SPHERE,

	defineBaseVertices: function(){

		var g = new THREE.Geometry(),
		t = 72,
		a = Math.sin($m.A_R(t)),
		b = 0.5 / Math.sin($m.A_R(t) / 2) / Math.sin($m.A_R(t)),
		c = $m.R_A(Math.asin(b)),
		d = 180-c,
		e = 36,
		x,y,z;
		g.vertices.push(new THREE.Vector3(0,0,a));
		for(var h=0; h<=9; h++){
			x = a * Math.sin($m.A_R(c)) * Math.sin($m.A_R(e));
			y = a * Math.sin($m.A_R(c)) * Math.cos($m.A_R(e));
			z = Math.sin($m.A_R(t)) * Math.cos($m.A_R(c));
			if(e==0||e==180){x=0;};
			g.vertices.push(new THREE.Vector3(x,y,z));
			e+=t;
			if(h==4){e=0;c=d};
		}
		g.vertices.push(new THREE.Vector3(0,0,-a));
		for(var h=0; h<12; h++){
			g.vertices[h].normalize();
		}

		return g;					
	},

	defineBaseFaces: function( g , i ){

		g.faces.push(new fB(0,2,1)); 
		g.faces.push(new fD(0,3,2)); 
		g.faces.push(new fB(0,4,3)); 
		g.faces.push(new fE(0,5,4));
		g.faces.push(new fE(5,0,1)); 
		g.faces.push(new fE(1,6,5));
		g.faces.push(new fA(1,7,6));
		g.faces.push(new fE(1,2,7));
		g.faces.push(new fB(2,8,7));
		g.faces.push(new fE(2,3,8)); 
		g.faces.push(new fB(3,9,8));
		g.faces.push(new fE(3,4,9));
		g.faces.push(new fB(4,10,9));
		g.faces.push(new fD(4,5,10));
		g.faces.push(new fC(5,6,10)); 
		g.faces.push(new fE(6,11,10));
		g.faces.push(new fB(7,11,6));
		g.faces.push(new fC(8,11,7));
		g.faces.push(new fA(9,11,8));
		g.faces.push(new fC(10,11,9));

		g.faces[0].cv =[{a:0, b:2}, {a:1, b:0}, {a:2, b:1}];
		g.faces[1].cv =[{a:2, b:0}, {a:0, b:3}, {a:3, b:2}];
		g.faces[2].cv =[{a:0, b:4}, {a:3, b:0}, {a:4, b:3}];
		g.faces[3].cv =[{a:4, b:0}, {a:5, b:4}, {a:0, b:5}];
		g.faces[4].cv =[{a:1, b:5}, {a:0, b:1}, {a:5, b:0}];
		g.faces[5].cv =[{a:5, b:1}, {a:6, b:5}, {a:1, b:6}];
		g.faces[6].cv =[{a:1, b:7}, {a:7, b:6}, {a:6, b:1}];
		g.faces[7].cv =[{a:7, b:1}, {a:2, b:7}, {a:1, b:2}];
		g.faces[8].cv =[{a:2, b:8}, {a:7, b:2}, {a:8, b:7}];
		g.faces[9].cv =[{a:8, b:2}, {a:3, b:8}, {a:2, b:3}];
		g.faces[10].cv =[{a:3, b:9}, {a:8, b:3}, {a:9, b:8}];
		g.faces[11].cv =[{a:9, b:3}, {a:4, b:9}, {a:3, b:4}];
		g.faces[12].cv =[{a:4, b:10}, {a:9, b:4}, {a:10, b:9}];
		g.faces[13].cv =[{a:10, b:4}, {a:4, b:5}, {a:5, b:10}];
		g.faces[14].cv =[{a:6, b:10}, {a:5, b:6}, {a:10, b:5}];
		g.faces[15].cv =[{a:10, b:6}, {a:11, b:10}, {a:6, b:11}];
		g.faces[16].cv =[{a:7, b:11}, {a:6, b:7}, {a:11, b:6}];
		g.faces[17].cv =[{a:11, b:7}, {a:8, b:11}, {a:7, b:8}];
		g.faces[18].cv =[{a:9, b:11}, {a:11, b:8}, {a:8, b:9}];
		g.faces[19].cv =[{a:11, b:9}, {a:10, b:11}, {a:9, b:10}];

		g.faces[0].s = [1,4,7];
		g.faces[1].s = [0,2,9];
		g.faces[2].s = [3,1,11];
		g.faces[3].s = [2,13,4];
		g.faces[4].s = [5,0,3];
		g.faces[5].s = [4,14,6];
		g.faces[6].s = [7,16,5];
		g.faces[7].s = [6,8,0];
		g.faces[8].s = [9,7,17];
		g.faces[9].s = [8,10,1];
		g.faces[10].s = [11,9,18];
		g.faces[11].s = [10,12,2];
		g.faces[12].s = [13,11,19];
		g.faces[13].s = [12,3,14];
		g.faces[14].s = [15,5,13];
		g.faces[15].s = [14,19,16];
		g.faces[16].s = [17,6,15];
		g.faces[17].s = [16,18,8];
		g.faces[18].s = [19,17,10];
		g.faces[19].s = [18,15,12];

		var f;

		for(var a=0; a<20; a++){
			f = g.faces[a];
			f.ID = a;
			f.cv[f.l[0]].c = -1;
			f.cv[f.l[0]].e = (f.ID * i);
			f.cv[f.l[0]].f = (f.ID * i) + 1;
			f.cv[f.l[1]].c = -1;
			f.cv[f.l[1]].e = (f.ID * i) + 1;
			f.cv[f.l[1]].f = (f.ID * i) + 2;
			f.cv[f.l[2]].c = -1;
			f.cv[f.l[2]].e = (f.ID * i) + 2;
			f.cv[f.l[2]].f = (f.ID * i);
		}
		return g;
	},

	expand4: function( g , CON ){

		var con = CON || false;

		var n=0, f, e, F, V, v=[];
		var f1,f2,f3,f4;
		var c0,c1,c2;

		v[4] = new THREE.Vector3(0,0,0);
		v[5] = new THREE.Vector3(0,0,0);
		v[6] = new THREE.Vector3(0,0,0);

		n=g.faces.length;

		for(var i=0; i<n; i++){

			F = g.faces;
			f = F[i];							
			V = g.vertices;
			for(var l=0; l<3; l++){
				L = f.l[l];
				e = F[f.s[L]];
				// determine if connecting face has already defined a new vertice between the pair of faces.
				// if it has already been defined then e.cv[L].c will be equal to the defined vertices index.
				// and this step ( creating a new vertex ) is skipped.
				if( e.cv[L].c == -1){
					v[l+4] = $m.mergeVectors(V[f.cv[L].a], V[f.cv[L].b], 0.5, true);
					g.vertices.push(v[l+4]);
					v[l+7] = g.vertices.length-1;						
					f.cv[L].c = v[l+7];
					f.cv[L].i = e.cv[L].f;
					f.cv[L].ii = e.cv[L].e;
					e.cv[L].c = v[l+7];
					e.cv[L].i = f.cv[L].f;
					e.cv[L].ii = f.cv[L].e;
				} 
			}
			
		}

		if( con ){

			for( var i=0; i<n; i++ ){

				f = g.faces[i];
				c0 = f.cv[f.l[0]];
				c1 = f.cv[f.l[1]];
				c2 = f.cv[f.l[2]];

				f1 = new f.fF(c0.a, c0.c, c2.c);
				f2 = new f.fF(c0.c, c0.b, c1.c);
				f3 = new f.fF(c2.c, c1.c, c2.a);
				f4 = new f.fF(c1.c, c2.c, c0.c);
				
				f1.ID = (f.ID*4);
				f2.ID = (f.ID*4)+1;
				f3.ID = (f.ID*4)+2;
				f4.ID = (f.ID*4)+3;

				f1.s=[];
				f1.s[f.l[0]] = c0.i;
				f1.s[f.l[2]] = c2.ii;
				f1.s[f.l[1]] = f4.ID;
				f2.s=[];
				f2.s[f.l[0]] = c0.ii;
				f2.s[f.l[1]] = c1.i;
				f2.s[f.l[2]] = f4.ID;
				f3.s=[];
				f3.s[f.l[1]] = c1.ii;
				f3.s[f.l[2]] = c2.i;
				f3.s[f.l[0]] = f4.ID;
				f4.s=[];
				f4.s[f.l[0]] = f3.ID;
				f4.s[f.l[1]] = f1.ID;
				f4.s[f.l[2]] = f2.ID;
				f1.cv=[];
				f1.cv[f.l[0]] = {a:c0.a, b:c0.c, c:-1, e:(f1.ID*4), f:(f1.ID*4)+1};
				f1.cv[f.l[1]] = {a:c0.c, b:c2.c, c:-1, e:(f1.ID*4)+1, f:(f1.ID*4)+2};
				f1.cv[f.l[2]] = {a:c2.c, b:c0.a, c:-1, e:(f1.ID*4)+2, f:(f1.ID*4)};
				f2.cv=[];
				f2.cv[f.l[0]] = {a:c0.c, b:c1.a, c:-1, e:(f2.ID*4), f:(f2.ID*4)+1};
				f2.cv[f.l[1]] = {a:c1.a, b:c1.c, c:-1, e:(f2.ID*4)+1, f:(f2.ID*4)+2};
				f2.cv[f.l[2]] = {a:c1.c, b:c0.c, c:-1, e:(f2.ID*4)+2, f:(f2.ID*4)};
				f3.cv=[];
				f3.cv[f.l[0]] = {a:c2.c, b:c1.c, c:-1, e:(f3.ID*4), f:(f3.ID*4)+1};
				f3.cv[f.l[1]] = {a:c1.c, b:c2.a, c:-1, e:(f3.ID*4)+1, f:(f3.ID*4)+2};
				f3.cv[f.l[2]] = {a:c2.a, b:c2.c, c:-1, e:(f3.ID*4)+2, f:(f3.ID*4)};
				f4.cv=[]
				f4.cv[f.l[0]] = {a:c1.c, b:c2.c, c:-1, e:(f4.ID*4), f:(f4.ID*4)+1};
				f4.cv[f.l[1]] = {a:c2.c, b:c0.c, c:-1, e:(f4.ID*4)+1, f:(f4.ID*4)+2};
				f4.cv[f.l[2]] = {a:c0.c, b:c1.c, c:-1, e:(f4.ID*4)+2, f:(f4.ID*4)};
				
				g.faces.push(f1);
				g.faces.push(f2);
				g.faces.push(f3);
				g.faces.push(f4);
			}

		} else {

			for(var i=0; i<n; i++){

				f = g.faces[i];
				c0 = f.cv[f.l[0]];
				c1 = f.cv[f.l[1]];
				c2 = f.cv[f.l[2]];

				f1 = new f.fF(c0.a, c0.c, c2.c);
				f2 = new f.fF(c0.c, c0.b, c1.c);
				f3 = new f.fF(c2.c, c1.c, c2.a);
				f4 = new f.fF(c1.c, c2.c, c0.c);

				g.faces.push(f1);
				g.faces.push(f2);
				g.faces.push(f3);
				g.faces.push(f4);
			}
		}
		g.faces.splice(0,n);

		return g;
	}

}
